//+------------------------------------------------------------------+
//|                                             Sample_MACrossEA.mq5 |
//|                               Copyright 2009, Fai Software Corp. |
//|                                    http://d.hatena.ne.jp/fai_fx/ |
//+------------------------------------------------------------------+
#property copyright "2009, Fai Software Corp."
#property link      "http://d.hatena.ne.jp/fai_fx/"
#property version   "1.00"

#include <Trade\Trade.mqh>

//--- input parameters
input int      TakeProfit = 150;
input int      StopLoss   = 300;
input double   Lots       = 0.1;
input ulong    MagicNumber= 1024;
input int      MAFast     =  6;
input int      MASlow     = 12;


int iMAFast_handle,iMASlow_handle;
double MAFastBuffer[];
double MASlowBuffer[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   iMAFast_handle =  iMA(Symbol(),PERIOD_CURRENT,MAFast,0,MODE_EMA,PRICE_CLOSE);
   iMASlow_handle =  iMA(Symbol(),PERIOD_CURRENT,MASlow,0,MODE_EMA,PRICE_CLOSE);
   ArraySetAsSeries(MAFastBuffer,true);
   ArraySetAsSeries(MASlowBuffer,true);
//---

//StopLoss TakeProfit value check.
   double Ask,Bid;
   int Spread;
   Ask    = SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   Bid    = SymbolInfoDouble(Symbol(),SYMBOL_BID);
   Spread = (int)SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
   if(Spread==0) Spread=(int)((Ask-Bid)/Point());// Spread floating broker.
   int stoplevel= Spread + (int)SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL);
   if(StopLoss <=stoplevel || TakeProfit <=stoplevel)
      Print("Warning Spread + stoplevel=",stoplevel," Spread=",Spread,">> sl=",StopLoss," tp=",TakeProfit);

   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
// Check Position.When Opend,do nothing.
   if(PositionSelect(_Symbol)) return;

// Get indicator value.
   int Bars=Bars(Symbol(),PERIOD_CURRENT);
   int copied;
   copied=CopyBuffer(iMAFast_handle,0,0,Bars,MAFastBuffer);
   if(copied<3) return;
   copied=CopyBuffer(iMASlow_handle,0,0,Bars,MASlowBuffer);
   if(copied<3) return;


// Send Order
   if(MAFastBuffer[1]>MASlowBuffer[1] && MAFastBuffer[2]<=MASlowBuffer[2])
     {
      PrintFormat("BUY  MA %.6f %.6f %.6f %.6f ",MAFastBuffer[1],MASlowBuffer[1],MAFastBuffer[2],MASlowBuffer[2]);
      OpenPosition(ORDER_TYPE_BUY);
        }else if(MAFastBuffer[1]<MASlowBuffer[1] && MAFastBuffer[2]>=MASlowBuffer[2]){
      PrintFormat("SELL MA %.6f %.6f %.6f %.6f ",MAFastBuffer[1],MASlowBuffer[1],MAFastBuffer[2],MASlowBuffer[2]);
      OpenPosition(ORDER_TYPE_SELL);
     }

  }
//+------------------------------------------------------------------+

void OpenPosition(ENUM_ORDER_TYPE direction)
  {

   class CTrade       *MyTrade;
   MyTrade=new CTrade;
   if(MyTrade==NULL) return;

   double Ask,Bid;
   int Spread;
   Ask    = SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   Bid    = SymbolInfoDouble(Symbol(),SYMBOL_BID);
   Spread = (int)SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
   if(Spread==0) Spread=(int)((Ask-Bid)/Point());// Spread floating broker.

   int stoplevel= Spread + (int)SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL);
   if(StopLoss <=stoplevel || TakeProfit <=stoplevel)
      Print("Spread + stoplevel=",stoplevel," SP=",Spread," sl=",StopLoss," tp=",TakeProfit);

   double price,sl,tp;
   if(direction==ORDER_TYPE_BUY)
     {
      price  = Ask;
      sl     = Ask - StopLoss*_Point;
      tp     = Ask + TakeProfit*_Point;
        }else{
      price  = Bid;
      sl     = Bid + StopLoss*_Point;
      tp     = Bid - TakeProfit*_Point;
     }
/*PositionOpen(const string symbol,ENUM_ORDER_TYPE order_type,double volume,
                            double price,double sl,double tp,ulong deviation,
                            ulong expert=0,const string comment="");*/
   bool ret=MyTrade.PositionOpen(_Symbol,direction,Lots,
                                 price,sl,tp,3,
                                 MagicNumber,"MN"+(string)MagicNumber);

   string msg="ret="+(string)ret+"\nretcode="+MyTrade.ResultRetcodeString()+"\ndeal="
              +(string)MyTrade.ResultDeal()+"\norder="+(string)MyTrade.ResultOrder();

   Comment(msg);
   Print(msg);
//--- deleting objects
   if(MyTrade!=NULL) delete MyTrade;

  }
//+------------------------------------------------------------------+
